From 29ccbe950d569a9da75b291a68715503141dea03 Mon Sep 17 00:00:00 2001
From: bill-auger <mr.j.spam.me@gmail.com>
Date: Jul 14 2023 01:23:35 +0000
Subject: [PATCH 14/32] [scripts/version_constraint.sh]: refactor


---

diff --git a/scripts/version_constraint.sh b/scripts/version_constraint.sh
index 53db47d..d124d9d 100755
--- a/scripts/version_constraint.sh
+++ b/scripts/version_constraint.sh
@@ -7,22 +7,30 @@ _version_constraint() # (dep_pkgname [precision])
 
   local dep_pkgname=$1
   declare -i req_precision=$2
-  local full_version=$(pacman -S --print-format='%v' ${dep_pkgname} | tail -n 1)
+  local full_version=$(pacman -S --print-format='%v' ${dep_pkgname} 2> /dev/null | tail -n 1)
   local n_dots=$(tmp=${full_version%-*} ; tmp=${tmp//[^\.]} ; echo "${#tmp}" ;)
   local def_precision=$(( n_dots + 1 ))
   local is_prec_valid=$(( req_precision > 0 && req_precision <= def_precision ))
   local precision=$( (( is_prec_valid )) && echo ${req_precision} || echo ${def_precision} )
-  local pkgver_rx='[^-\.\ ]+'
+  local pkgver_rx='[0-9A-Za-z_]+'
+  pkgver_rx=$(sed 's|\]|\+]|' <<<${pkgver_rx}) # according to the wiki, '+' is not allowed,
+                                               # but some pkgver have it (eg: 5.15.10+kde+r130)
   local subver_rx='\.'${pkgver_rx}
-  local pkgrel_rx='[^-\ ]+'
+  local pkgrel_rx='[0-9]+'
+  local garbage_rx='[^0-9].*'
   local capture_rx=${pkgver_rx}
   for (( n_dots=1 ; n_dots < precision ; ++n_dots )) ; do capture_rx+=${subver_rx} ; done ;
-  local version pkgrel subver_inc pkgrel_inc version_min version_max constraint_string
-
-  if   [[ "${full_version}" =~ ^(${capture_rx})(${subver_rx})*-(${pkgrel_rx})$ ]]
-  then version=${BASH_REMATCH[1]}
-       pkgrel=${BASH_REMATCH[3]%%.*}
-       subver_inc=$(( ${version##*.} + 1 )) # NOTE: this right-trims from any non-numeric
+  local version pkgrel has_split_char version_min version_max constraint_string
+  declare -i subver subver_inc pkgrel_inc
+
+  if   [[ "${full_version}" =~ ^(${capture_rx})(${subver_rx})*-(${pkgrel_rx})[^0-9]*$ ]]
+  then version=${BASH_REMATCH[1]} # pkgver cut to the requested precision
+       #unused=${BASH_REMATCH[2]} # discarded pkgver segments
+       pkgrel=${BASH_REMATCH[3]}  # pkgrel with non-numerics right-trimmed
+       has_split_char=$(grep '\.' <<<${version} &> /dev/null ; echo $((! $?)) ; )
+       subver=$(sed "s|${garbage_rx}||" <<<${version##*.}) # right-trim from any non-numeric
+       version=$( ((has_split_char)) && echo ${version%.*}.${subver} || echo ${subver} )
+       subver_inc=$(( subver + 1 ))
        pkgrel_inc=$(( pkgrel + 1 ))
        version_min=$(   (( ! is_prec_valid    )) && echo ${full_version%-*}-${pkgrel} || \
                                                     echo ${version}                      )
@@ -44,17 +52,17 @@ _version_constraint() # (dep_pkgname [precision])
 
 # NOTE: test data versions are extremely brittle - these will need adjustments routinely
 #       usually, these values will be the reported failed 'actual' - `pacman -Syu` first!
-readonly OPENEXR_VER_MIN_PR_1=3                      ; OPENEXR_VER_MAX_PR_1=4 ;
-readonly OPENEXR_VER_MIN_PR_2=3.1                    ; OPENEXR_VER_MAX_PR_2=3.2 ;
-readonly OPENEXR_VER_MIN_PR_3=3.1.9                  ; OPENEXR_VER_MAX_PR_3=3.1.10 ;
-readonly OPENEXR_VER_MIN_FULL=3.1.9-1                ; OPENEXR_VER_MAX_FULL=3.1.9-2 ;
-readonly OPENSHADINGLANGUAGE_VER_MIN_PR_1=1          ; OPENSHADINGLANGUAGE_VER_MAX_PR_1=2 ;
-readonly OPENSHADINGLANGUAGE_VER_MIN_PR_2=1.12       ; OPENSHADINGLANGUAGE_VER_MAX_PR_2=1.13 ;
-readonly OPENSHADINGLANGUAGE_VER_MIN_PR_3=1.12.13     ; OPENSHADINGLANGUAGE_VER_MAX_PR_3=1.12.14 ;
-readonly OPENSHADINGLANGUAGE_VER_MIN_PR_4=1.12.13.0   ; OPENSHADINGLANGUAGE_VER_MAX_PR_4=1.12.13.1 ;
-readonly OPENSHADINGLANGUAGE_VER_MIN_FULL=1.12.13.0-1 ; OPENSHADINGLANGUAGE_VER_MAX_FULL=1.12.13.0-2 ;
-readonly WEBKIT2GTK_VER_MIN=2.40.3-1                 ; WEBKIT2GTK_VER_MAX=2.40.3-2 ;
-readonly QT5BASE_VER_MIN=5.15.10+kde+r130            ; QT5BASE_VER_MAX=5.15.11 ;
+readonly OPENEXR_VER_MIN_PR_1=3
+readonly OPENEXR_VER_MIN_PR_2=3.1
+readonly OPENEXR_VER_MIN_PR_3=3.1.9
+readonly OPENEXR_VER_MIN_FULL=3.1.9-1
+readonly OPENSHADINGLANGUAGE_VER_MIN_PR_1=1
+readonly OPENSHADINGLANGUAGE_VER_MIN_PR_2=1.12
+readonly OPENSHADINGLANGUAGE_VER_MIN_PR_3=1.12.13
+readonly OPENSHADINGLANGUAGE_VER_MIN_PR_4=1.12.13.0
+readonly OPENSHADINGLANGUAGE_VER_MIN_FULL=1.12.13.0-1
+readonly WEBKIT2GTK_VER_MIN_FULL=2.40.3-1
+readonly QT5BASE_VER_MIN_PR_3=5.15.10
 
 readonly RED='\033[01;31m'
 readonly GREEN='\033[00;32m'
@@ -62,17 +70,43 @@ readonly AQUA='\033[00;36m'
 readonly CEND='\033[00m'
 
 
+VerIncrement() # (version_string split_char)
+{
+  # NOTE This is not the same parsing logic as _version_constraint().
+  #      It is intended to be as simple as possible, only for the mock data.
+  #      Do not pass in unconventional version chars, such as '+'.
+  local version_string=$1
+  local split_char=$2
+  local has_split_char=$(grep "\\${split_char}" <<<$1 &> /dev/null ; echo $((! $?)) ; )
+  local unchanged_segment=${version_string%${split_char}*}
+  declare -i incremented_segment=$(( ${version_string##*${split_char}} + 1 ))
+
+  ((! has_split_char)) || echo -n ${unchanged_segment}${split_char}
+  echo ${incremented_segment}
+}
+readonly OPENEXR_VER_MAX_PR_1=$(            VerIncrement ${OPENEXR_VER_MIN_PR_1} '.')
+readonly OPENEXR_VER_MAX_PR_2=$(            VerIncrement ${OPENEXR_VER_MIN_PR_2} '.')
+readonly OPENEXR_VER_MAX_PR_3=$(            VerIncrement ${OPENEXR_VER_MIN_PR_3} '.')
+readonly OPENEXR_VER_MAX_FULL=$(            VerIncrement ${OPENEXR_VER_MIN_FULL} '-')
+readonly OPENSHADINGLANGUAGE_VER_MAX_PR_1=$(VerIncrement ${OPENSHADINGLANGUAGE_VER_MIN_PR_1} '.')
+readonly OPENSHADINGLANGUAGE_VER_MAX_PR_2=$(VerIncrement ${OPENSHADINGLANGUAGE_VER_MIN_PR_2} '.')
+readonly OPENSHADINGLANGUAGE_VER_MAX_PR_3=$(VerIncrement ${OPENSHADINGLANGUAGE_VER_MIN_PR_3} '.')
+readonly OPENSHADINGLANGUAGE_VER_MAX_PR_4=$(VerIncrement ${OPENSHADINGLANGUAGE_VER_MIN_PR_4} '.')
+readonly OPENSHADINGLANGUAGE_VER_MAX_FULL=$(VerIncrement ${OPENSHADINGLANGUAGE_VER_MIN_FULL} '-')
+readonly WEBKIT2GTK_VER_MAX_FULL=$(         VerIncrement ${WEBKIT2GTK_VER_MIN_FULL} '-')
+readonly QT5BASE_VER_MAX_PR_3=$(            VerIncrement ${QT5BASE_VER_MIN_PR_3} '.') ;
+
+
 TestVersionConstraint() # ("pkgname" "precision" "expected_res")
 {
   local pkgname="$1"
   local precision="$2"
   local expected_res="$3"
 
-  local actual_res="$(_version_constraint "${pkgname}" "${precision}" 2> /dev/null)"
-# local actual_res="$(_version_constraint "${pkgname}" "${precision}")"
+  local actual_res="$(_version_constraint "${pkgname}" "${precision}")"
 
   if   [[ "${actual_res}" == "${expected_res}" ]]
-  then echo -e "${GREEN}PASS <- ${pkgname}${CEND}"                                     ; return 0 ;
+  then echo -e "${GREEN}PASS <- ${pkgname}${CEND}"                                      ; return 0 ;
   else echo -e "${RED}FAIL <- ${pkgname}${CEND}"
        echo -e "${AQUA}  expected='${expected_res}'\n  actual  ='${actual_res}'${CEND}" ; return 1 ;
   fi
@@ -106,10 +140,10 @@ RunTests()
   TestVersionConstraint 'non-existent-package' "${precision}" ''
 
   precision= ; echo -e "\n=== specific repo ===" ;
-  TestVersionConstraint 'extra/webkit2gtk'     "${precision}" "extra/webkit2gtk>=${WEBKIT2GTK_VER_MIN} extra/webkit2gtk<${WEBKIT2GTK_VER_MAX}"
+  TestVersionConstraint 'extra/webkit2gtk'     "${precision}" "extra/webkit2gtk>=${WEBKIT2GTK_VER_MIN_FULL} extra/webkit2gtk<${WEBKIT2GTK_VER_MAX_FULL}"
 
   precision=3 ; echo -e "\n=== non-numeric version ===" ;
-  TestVersionConstraint 'qt5-base'             "${precision}" "qt5-base>=${QT5BASE_VER_MIN} qt5-base<${QT5BASE_VER_MAX}"
+  TestVersionConstraint 'qt5-base'             "${precision}" "qt5-base>=${QT5BASE_VER_MIN_PR_3} qt5-base<${QT5BASE_VER_MAX_PR_3}"
 }
 
 

